<?php
/*
Plugin Name: Menealo
Plugin URI: http://86400.es/menealo-plugin-wordpress/
Description: Permite integrar la caja de meneos de Meneame.net en tus posts
Version: 0.2
Author: Alex dantart
Author URI: http://86400.es
*/

////////////////////////////////////////////////////////////////////////////////
// Plugin options etc.
////////////////////////////////////////////////////////////////////////////////

error_reporting(0);
$mene_val; 
$mene_opt = get_option('plugin_menealo');
if ( !is_array($mene_opt) ) {
	$mene_opt = array(
		'menealo-posicion-1' => "com",
		'menealo-posicion-1' => "der",
		'menealo-dias' => "5",
		'menealo-log' => "1",
	);	
}

add_filter('preprocess_comment', 'mene_main', 1, 1);
add_action('admin_menu', 'mene_add_options_to_admin');
add_action('wp_head','mene_estilos');
add_filter('the_content', 'mene_addbox');

########################################################################################################################
#					MAIN FUNCTIONS
########################################################################################################################

function mene_main($incomingTB) {
	global $mene_opt, $mene_val;
	if ( ereg("back", $incomingTB['comment_type']) && ereg("http://meneame.net/story",$incomingTB['comment_author_url'])) {
		$votos = mene_votos(get_permalink($incomingTB['comment_post_ID']));
		$data = Array(
			"url" => $incomingTB['comment_author_url'],
			"time" => time(),
			"votos" => $data_meneame[2],
			"votos_time" => time(),
			);
		add_post_meta($incomingTB['comment_post_ID'], 'menealo-data', serialize($data));
		mene_log_addentry($incomingTB['comment_post_ID'],$incomingTB['comment_author_url']);
	}
	return $incomingTB;
}

function mene_addbox($content) {
	global $mene_opt, $post;
	if ($custom_value = get_post_custom_values("menealo-data")) { // Fue meneada

		$unse = unserialize($custom_value[0]);
		if (is_array($unse)) { $data = $unse; } else { $data = unserialize($unse); } // algunas versiones de WP guardan array y otras cadena (parche para arreglarlo)
		
		$url = $data["url"];
		$time = $data["time"];
		$votos = $data["votos"];
		$votos_time = $data["votos_time"];
	
		$last_time = (time()-$votos_time);
		if ( $last_time > 180) { // Cada 3 minutos cogemos de nuevo los votos del API de meneame
			$votos = mene_votos(get_permalink($post->ID));
			$data["votos"] = $votos;
			$data["votos_time"] = time();
			update_post_meta($post->ID, 'menealo-data', serialize($data));
		}
				
		if ($mene_opt["menealo-posicion-2"]=="der") {
			$float = "float:right;";
		} else 	if ($mene_opt["menealo-posicion-2"]=="izq") {
			$float = "float:left;";
		} else {
			$float = "";
		}

		$caja = '<div id="caja" style="'.$float.'"><div class="news-shakeit"><div class="mnm-published"><a href="'.$url.'">'.$votos.'</a>meneos</div><div class="menealo"><a href="'.$url.'">menéalo</a></div></div></div>';

		if ((time()-$time) < ($mene_opt["menealo-dias"]*86400) ) {
			if ($mene_opt["menealo-posicion-1"]=="com") { $content = $caja . $content; } else { $content = $content . $caja; }
		}
		
	}
	return $content;	
}

function mene_votos($url) {
	$datos = explode(" ",implode("",file("http://meneame.net/api/url.php?url=".$url)));
	return $datos[2];
}

function mene_estilos() {
	echo "<style type='text/css'>#caja { margin:10px; border:0; } .news-shakeit { font-family:sans-serif; width: 65px; text-align: center;font-size: 10.2pt;margin: 5px 0 0 0;padding: 0;} .mnm-published a, .mnm-queued a, .mnm-discarded a { display: block; font-size: 16pt; font-weight: normal; height: 19pt !important; letter-spacing: -1px; text-decoration: none; border-bottom: 0; vertical-align: bottom; }  .mnm-published a:hover { text-decoration: none; border-bottom: 0; }  .mnm-published {  display: block; padding: 4px 0 4px 0; }  .mnm-published a:hover, .mnm-queued a:hover, .mnm-discarded a:hover { color: #03A; } .mnm-published, .mnm-published a { color: #FFF; text-decoration:none; }  .mnm-published { background: #FF6400 url(".mene_get_resource_url('elefante.png').") top left no-repeat; }  .menealo a { text-decoration:none;  border: 1px solid; }  .menealo a, .menealo span { border-bottom: 0px; text-decoration:none;  margin-top: 2px; display: block; } .menealo a:hover, .menealo span:hover { border-bottom: 0px; text-decoration:none; }  .menealo span { border: 1px dotted; } .menealo { background-color: #fff; }  .menealo a { background: url(".mene_get_resource_url('fondo.png').") bottom left repeat-x; border-color: #FFCBAA; }  .menealo a, .menealo span { color: #FF6400; }  .menealo span { border-color: #FF6400; } </style>";
}
########################################################################################################################
#					ADMINISTRATION
########################################################################################################################

function mene_add_options_to_admin() {
    if (function_exists('add_options_page')) {
		add_options_page('Menéalo', 'Menéalo', 8, basename(__FILE__), 'mene_adminOptions');
    }
}

function mene_adminOptions() {

	global $mene_opt;

	add_option('plugin_menealo', $mene_opt, 'Menealo Opciones');
	if (isset($_POST['submit']) ) {
		$mene_opt_update = array (
			'menealo-posicion-1' => $_POST['menealo-posicion-1'],
			'menealo-posicion-2' => $_POST['menealo-posicion-2'],
			'menealo-dias' => $_POST['menealo-dias'],
			'menealo-log' => $_POST['menealo-log'],
		);
		update_option('plugin_menealo', $mene_opt_update);
	}

	$mene_opt = get_option('plugin_menealo');
	?>

	<style type="text/css">
		fieldset{margin:20px 0; border:1px solid #cecece; padding:15px;	}
		legend { font-size: 1.2em; font-weight:bold;}
	</style>
	
	<div class="wrap">

		<h2>Menéalo</h2>

		<?php if (mene_isOldWordpress()) echo '<p style="color: red; font-weight: bold">Estás usando uan versión de Wordpress que no está soportada por este plugin. Actualiza tu versión en <a href="http://wordpress.org/download/">wordpress.org</a>.</p>'; ?>
		<form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . basename(__FILE__); ?>&updated=true">
		<div>
			<fieldset>
				<legend>Posición de la caja de meneos en el post</legend>
				<p>
					En el texto de tu artículo puedes integrar la caja de meneos automáticamente tanto al principio, como al final del texto. Además puedes ponerla como una caja independiente del texto, o incluida dentro del mismo, a la izquierda o a la derecha. <b>Consejo</b>: al comienzo del texto a la derecha, de esta forma, tendrás más visibilidad y posibilidad de más meneos.
				</p>
				<p>
					Posición de la caja respecto al artículo:
					<select id="menealo-posicion-1" name="menealo-posicion-1">
					<option value="com" <?php check_selected('com','menealo-posicion-1');?>>Al comienzo del texto</option>
					<option value="fin" <?php check_selected('fin','menealo-posicion-1');?>>Al final del texto</option>
					</select>
				</p>
				<p>
					Posición de la caja respecto al texto:
					<select id="menealo-posicion-2" name="menealo-posicion-2">
					<option value="izq" <?php check_selected('izq','menealo-posicion-2');?>>A la izquierda</option>
					<option value="der" <?php check_selected('der','menealo-posicion-2');?>>A la derecha</option>
					<option value="ind" <?php check_selected('ind','menealo-posicion-2');?>>Independiente</option>
					</select>
				</p>			

			</fieldset>

			<fieldset>
				<legend>Aparición de la caja de meneos antiguos no publicados</legend>
				<p>
					A los días de que una noticia se ha meneado, se cierra y ya no se permiten más votos. Normalmente suele ser del orden de 1 semana para noticias que no han llegado a portada y algo más para las que si lo hicieron. Esto permite fijar un período de días en el que la caja de meneos aparece o no en el artículo de tu blog.	<b>Consejo</b>: 5 días es suficiente. Si tras este período no ha salido en portada, se suele cerrar los meneos.
				</p>
				<p>
					<label for="menealo-dias">Margen de días en el que aparecerá la caja de meneos tras ser meneada</label> 	<input type="text" name="menealo-dias" id="menealo-dias" size="4" maxlength="2" value="<?php echo($mene_opt['menealo-dias']) ?>" />
				</p>
			</fieldset>

			<fieldset>
				<legend>Log de meneos</legend>
				<p>
					<label for="menealo-log"><input type="checkbox" value="1" name="menealo-log" id="menealo-log" <?=($mene_opt['menealo-log']?"checked":"")?> value="<?php echo($mene_opt['menealo-log']) ?>" /> Guardar un histórico de los posts meneados </label> 
				</p>
			</fieldset>
	
		<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Options &raquo;') ?>" /></p>

		</div>
		</form>

		<h2>Posts meneados</h2>

		<?php mene_log_display(); ?>
	

		<p style="margin-top: 30px; text-align: center; font-size: .85em;">&copy; Copyright 2008&nbsp;&nbsp;<a href="http://86400.es">Alex Dantart</a></p>
	
	</div>
	<?php
}


########################################################################################################################
#					OTHER FUNCTIONS
########################################################################################################################

function check_selected($value, $theFieldname){
	global $mene_opt;
	if ($mene_opt[$theFieldname]=="$value") echo " selected ";
}

function mene_isOldWordpress() {
	global $wp_version;
	if (preg_match("/^1\./", $wp_version)) {  return true; } else {	return false; }
}

////////////////////////////////////////////////////////////////////////////////
// Add log entry 
////////////////////////////////////////////////////////////////////////////////
function mene_log_addentry($post_id, $logmsg) {
	global $mene_val;
	if ($log = get_option('plugin_menealo_log')) {
		if ( ! is_array($log) )  $log = array();
		$log[] = Array($post_id,$logmsg);
		update_option('plugin_menealo_log', $log);
	} else {
		add_option('plugin_menealo_log', 'empty', 'Menealo Log', 'no');
	}
}

////////////////////////////////////////////////////////////////////////////////
// Display log 
////////////////////////////////////////////////////////////////////////////////
function mene_log_display() {

	global $mene_opt;
	if ($mene_opt['menealo-log'] == '1') {
		wp_cache_delete('plugin_menealo_log', 'options');
        $result = '<ul>';
		$log = get_option('plugin_menealo_log');
		if ( is_array($log) ) {
			$log = array_reverse($log);
			$count = 0;
			foreach($log as $logline) {
				$result .= "<li><a href='".get_the_title($logline[0])."'>".get_permalink($logline[0])."</a> en <a href='".$logline[1]."'>".$logline[1]."</a>";
				$count++;
			}
			$result .= '</ul>';
		} else {
			$result .= '<p>Sin ningún trackback de menéame automático.</p>';
		}
		
		echo '<h3 class="log">Últimos posts que te han meneado:</h3>' . "\n" . $result;

	} else {
		update_option('plugin_menealo_log', 'empty');
	}

}

////////////////////////////////////////////////////////////////////////////////
// Icons
////////////////////////////////////////////////////////////////////////////////
if(isset($_GET['resource']) && !empty($_GET['resource'])) {
	# base64 encoding performed by base64img.php from http://php.holtsmark.no 
	$resources = array(
		'elefante.png' =>
			'iVBORw0KGgoAAAANSUhEUgAAAEYAAABECAMAAAALOLO9AAAAmV'.
			'BMVEX/ZAD/ZQD/ZgD/ZwD/aAD/aQD/agD/awD/bAD/bQD/bgD/'.
			'bwD/cAD/cQD/cgD/cwD/dAD/dQD/dgD/dwD/eAD/eQD/egD/ew'.
			'D/fAD/fQD/fgD/fwD/gAD/gQD/ggD/gwD/hAD/hQD/hgD/hwD/'.
			'iAD/iQD/igD/iwD/jAD/jQD/jgD/jwD/kAD/kQD/kgD/kwD/lA'.
			'D/lQD/lgDkwoOnAAAAAWJLR0QAiAUdSAAAAAlwSFlzAAALEwAA'.
			'CxMBAJqcGAAAAAd0SU1FB9YBAwwvB6IEh2YAAAU8SURBVHjalV'.
			'jpmqsgDBUUd60LLtTu7XTvWHn/h7sBe2daxdbhT/shHiA5OUnU'.
			'NC3S3g7DCXwTaZ9GUA0+ctn+2nA5bocVNd/B7Kj88TvTKF5988'.
			'64FPoQis0D+dbp9Sbs1r55vx63y9n6/6nuc0MNk3NLot2fNnKW'.
			'8qV6FT+95LGjvJ3alFseyjc5e0zg9CCXVz7SsOX5UUJpHHq2gT'.
			'SjEvArlb0vXFrFaGoJ5y3uAuQQw0t+UrKnUcYecsQWawXMndvy'.
			'F068ZOwsMJq1p2E/Y/1RhvoUFiz7MDWXftSn+4c7vqdEMybtOb'.
			'LQc0yCkUFsN26n/A2sSRWXkpchzC63l68qBoPbidw5cV/di8yg'.
			'ENAn2Krn+B2vWg8/djBCsZZRW2VIFMGjGVhv1n3CmrN4AeWMGh'.
			'i7qTx5TIZoZuaM7RvedBldHvhUevzHjkWgvyG9XrI5WCfp0g+4'.
			'IHlsicuUdOJ8iEGTCYbPO7MxK5o6ln+JPSKSIfoEnY898Dhu+N'.
			'rQxo90x5umN1mSBLg/GQ/j7CDeupMWy5EPXNgGo3GAqdfeZMJi'.
			'hLKa81OCxsEcVDAoZRnwfw7Re8tHAUHknTUVDguQZq2EwMUjYM'.
			'DhGxXHY2A/8NLZAtDR/6jesIopKWoBxykQzxd6kn+ycMOvWajc'.
			'DfmgA7mHQFR5Gx1vD7NJtU2qfIonIp48LQVThx/cfWOBRurZQN'.
			'QJGcidqOG3N8EZCfljIAEpXwwsIUKw6KIfwE8ocNgTyzVTSFU5'.
			'GL9Cghs+G3qeCHZNWajhCJs1T4fWYSqEYD/wNJMpj5UYpDYzKG'.
			'8GQxHIeOa3ZzL8KJ0n5PxSAVmlxJTkwOtBnUT08gKDsstxVdKy'.
			'krljA7fOsTx3UYC5V4NWtOpO5KGgOpxO5/P5UJhwZ/Y4nsNyEL'.
			'BB0mNVAD84ITzg/SrnvK+Dv7I0+EzkBfbLTVywK+d0ACZ+DWAj'.
			'8B0CAqLbIvuU7ossr8HmAzCsG1Uu1ARt6s3DF8/gUmSJgapvy+'.
			'9Zj9+maVkW6apaII6jJpnR8Es6UpXhOFDauapHlPOv0fIesL2y'.
			'UJFCsLS00cdZ8hey/jgV6iSGxsJoIQQyV5S6BbCGjs99egl5Qp'.
			'EHIPMt/pBCtWjXLwwgiqGWYs4fYEQ66ZMeLLZj+h9g8FZBZOPO'.
			'm+oPpoGxVuTQXCjtE52wTizbwu9gFgqYCwhR+d/d+f7+qHLr87'.
			'aigVrp5v1LQSqr2X8/JRJgzRLXeHecYx8GxPaLkacLUvzJNET0'.
			'Bp0pYGT1E91T3oxgc9av/kuw1q9GLvg1CCdRnCSTwLWJPpiLO8'.
			'UDAklcl/gX5iKrfhoFvufYlqkr2zrYOu0yuGa/WjbjV5Z5742D'.
			'RK82T7pZ/sDMJzH9/igYlSismN/V8kP+TMX7J5SZSKOMvRLKgg'.
			'T9dM2U8/cgtijyoDDolGc6cLhOf5wcNJy8AZElJ/+eMdbRYksU'.
			'taDnDyD3ohbrVh9Wsju+ziHrdNjlsLls4a8tkPXF1fpF0lXbpj'.
			'cVtD1l98gEWsCZ3OS7Ah8Zy05iRSY0w4vd5f9Xgp3sGnveRDAb'.
			'meVJrtkneNqIwMCmG6ZFtT7cXr401JtU9qSu6tuGKEaROaFsuT'.
			'sdqz0Nd1feH81x6pNYpuNAnS5YWx7LMWE2JpbjhVFC8xIcS+OJ'.
			'71ggG8RL2oZyQLVd2ffmPm5N3l+FDMuNikdbGg4qAG4baCYacv'.
			'3p4pjYXhjT4ukbQUreN6VhkrWlf+ogyxVXKnqfGWJ3VPrAcHhi'.
			'EEsKDs3yAkqcIqNpHE1ANrrZ9h/qobKIyaBhVAAAAABJRU5Erk'.
			'Jggg==',
		'fondo.png' => 
			'iVBORw0KGgoAAAANSUhEUgAAAAMAAAAMBAMAAABVUBpZAAAAJF'.
			'BMVEX/uo3/vpT/w5z/x6P/zKv/0bP/1br/2sL/3sn/49H/6Nj/'.
			'7OCrSTiTAAAAAWJLR0QAiAUdSAAAAAlwSFlzAAAN1wAADdcBQi'.
			'ibeAAAAAd0SU1FB9YLHAwwBlqT5gYAAAAsSURBVAjXY9i9gWHV'.
			'AoaZExg6GhjKCxjSEhhCAxhcHBiMDRiUFBgEBRgYGADQtgiD7o'.
			'ri+AAAAABJRU5ErkJggg==',
	); 
				
	if(array_key_exists($_GET['resource'],$resources)) {
		$content = base64_decode($resources[ $_GET['resource'] ]);
		$lastMod = filemtime(__FILE__);
		$client = ( isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) ? $_SERVER['HTTP_IF_MODIFIED_SINCE'] : false );
		// Checking if the client is validating his cache and if it is current.
		if (isset($client) && (strtotime($client) == $lastMod)) {
			// Client's cache IS current, so we just respond '304 Not Modified'.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $lastMod).' GMT', true, 304);
			exit;
		} else {
			// Image not cached or cache outdated, we respond '200 OK' and output the image.
			header('Last-Modified: '.gmdate('D, d M Y H:i:s', $lastMod).' GMT', true, 200);
			header('Content-Length: '.strlen($content));
			header('Content-Type: image/' . substr(strrchr($_GET['resource'], '.'), 1) );
			echo $content;
			exit;
		}	
	}
}

////////////////////////////////////////////////////////////////////////////////
// Display Icons
////////////////////////////////////////////////////////////////////////////////
function mene_get_resource_url($resourceID) {
	return trailingslashit(get_bloginfo('siteurl')) . '?resource=' . $resourceID;
}


?>
